加载中...
235-二叉搜索树的最近公共祖先(Lowest Common Ancestor of a Binary Search Tree)
发表于:2021-12-03 | 分类: 简单
字数统计: 1.4k | 阅读时长: 5分钟 | 阅读量:

原文链接: https://leetcode-cn.com/problems/lowest-common-ancestor-of-a-binary-search-tree

英文原文

Given a binary search tree (BST), find the lowest common ancestor (LCA) of two given nodes in the BST.

According to the definition of LCA on Wikipedia: “The lowest common ancestor is defined between two nodes p and q as the lowest node in T that has both p and q as descendants (where we allow a node to be a descendant of itself).”

 

Example 1:

Input: root = [6,2,8,0,4,7,9,null,null,3,5], p = 2, q = 8
Output: 6
Explanation: The LCA of nodes 2 and 8 is 6.

Example 2:

Input: root = [6,2,8,0,4,7,9,null,null,3,5], p = 2, q = 4
Output: 2
Explanation: The LCA of nodes 2 and 4 is 2, since a node can be a descendant of itself according to the LCA definition.

Example 3:

Input: root = [2,1], p = 2, q = 1
Output: 2

 

Constraints:

  • The number of nodes in the tree is in the range [2, 105].
  • -109 <= Node.val <= 109
  • All Node.val are unique.
  • p != q
  • p and q will exist in the BST.

中文题目

给定一个二叉搜索树, 找到该树中两个指定节点的最近公共祖先。

百度百科中最近公共祖先的定义为:“对于有根树 T 的两个结点 p、q,最近公共祖先表示为一个结点 x,满足 x 是 p、q 的祖先且 x 的深度尽可能大(一个节点也可以是它自己的祖先)。”

例如,给定如下二叉搜索树:  root = [6,2,8,0,4,7,9,null,null,3,5]

 

示例 1:

输入: root = [6,2,8,0,4,7,9,null,null,3,5], p = 2, q = 8
输出: 6 
解释: 节点 2 和节点 8 的最近公共祖先是 6。

示例 2:

输入: root = [6,2,8,0,4,7,9,null,null,3,5], p = 2, q = 4
输出: 2
解释: 节点 2 和节点 4 的最近公共祖先是 2, 因为根据定义最近公共祖先节点可以为节点本身。

 

说明:

  • 所有节点的值都是唯一的。
  • p、q 为不同节点且均存在于给定的二叉搜索树中。

通过代码

高赞题解

解题思路

一、非递归解决

这题让求二叉搜索树的最近公共祖先,而二叉搜索树的特点就是 左子树的所有节点都小于当前节点,右子树的所有节点都大于当前节点,并且每棵子树都具有上述特点,所以这题就好办了,从更节点开始遍历

  • 如果两个节点值都小于根节点,说明他们都在根节点的左子树上,我们往左子树上找

  • 如果两个节点值都大于根节点,说明他们都在根节点的右子树上,我们往右子树上找

  • 如果一个节点值大于根节点,一个节点值小于根节点,说明他们他们一个在根节点的左子树上一个在根节点的右子树上,那么根节点就是他们的最近公共祖先节点。

画个图看一下,比如要找0和5的最近公共祖先节点,如下图所示

image.png


public TreeNode lowestCommonAncestor(TreeNode root, TreeNode p, TreeNode q) {

    //如果根节点和p,q的差相乘是正数,说明这两个差值要么都是正数要么都是负数,也就是说

    //他们肯定都位于根节点的同一侧,就继续往下找

    while ((root.val - p.val) * (root.val - q.val) > 0)

        root = p.val < root.val ? root.left : root.right;

    //如果相乘的结果是负数,说明p和q位于根节点的两侧,如果等于0,说明至少有一个就是根节点

    return root;

}

看一下运行结果

image.png


二、递归解决

也可把它改为递归的方式


public TreeNode lowestCommonAncestor(TreeNode root, TreeNode p, TreeNode q) {

    //如果小于等于0,说明p和q位于root的两侧,直接返回即可

    if ((root.val - p.val) * (root.val - q.val) <= 0)

        return root;

    //否则,p和q位于root的同一侧,就继续往下找

    return lowestCommonAncestor(p.val < root.val ? root.left : root.right, p, q);

}

如果嫌代码行数太多,那就一行解决


public TreeNode lowestCommonAncestor(TreeNode root, TreeNode p, TreeNode q) {

    return (root.val - p.val) * (root.val - q.val) <= 0 ? root : lowestCommonAncestor(p.val < root.val ? root.left : root.right, p, q);

}

三、参照236. 二叉树的最近公共祖先

这题和第 236 题不一样的地方,在于 236 题不是二叉搜索树,所以第 236 题不能使用上面的方法解决,但这题可以使用第 236 题的解法,这里也可以来看下第 236 题之前写过的题解 236. 二叉树的最近公共祖先


public TreeNode lowestCommonAncestor(TreeNode cur, TreeNode p, TreeNode q) {

    if (cur == null || cur == p || cur == q)

        return cur;

    TreeNode left = lowestCommonAncestor(cur.left, p, q);

    TreeNode right = lowestCommonAncestor(cur.right, p, q);

    //如果left为空,说明这两个节点在cur结点的右子树上,我们只需要返回右子树查找的结果即可

    if (left == null)

        return right;

    //同上

    if (right == null)

        return left;

    //如果left和right都不为空,说明这两个节点一个在cur的左子树上一个在cur的右子树上,

    //我们只需要返回cur结点即可。

    return cur;

}

统计信息

通过次数 提交次数 AC比率
184585 276724 66.7%

提交历史

提交时间 提交结果 执行时间 内存消耗 语言

相似题目

题目 难度
二叉树的最近公共祖先 中等
最小公共区域 中等
上一篇:
234-回文链表(Palindrome Linked List)
下一篇:
238-除自身以外数组的乘积(Product of Array Except Self)
本文目录
本文目录